package com.huimv.wine.ws.admin;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.wine.common.EventWsErrUtil;
import com.huimv.wine.entity.Manager;
import com.huimv.wine.entity.User;
import com.huimv.wine.entity.vo.AdminTradeQueryUserParam;
import com.huimv.wine.entity.vo.WsEvent;
import com.huimv.wine.mapper.UserMapper;
import com.huimv.wine.utils.Result;
import com.huimv.wine.utils.SpringContextUtil;
import com.huimv.wine.utils.WebsocketManagerUtil;
import org.springframework.stereotype.Component;

import javax.websocket.Session;

@Component
public class AdminTrade {
    public void handle(JSONObject message, Session session, Manager manager){
        String event = message.getString("event");
        JSONObject data = message.getJSONObject("data");
        UserMapper userMapper = SpringContextUtil.getBean(UserMapper.class);
        switch (event) {
            case "adminTradeQueryUser":
                queryUser(session, manager, data, userMapper);
                break;
            case "adminTradeQueryTrade":
                queryTrade(session, data);
                break;
            case "adminTradeRefund":
                refund(session, manager, data);
                break;
            default:
                WsEvent wsEvent = EventWsErrUtil.getWsErr("unrecognized event");
                WebsocketManagerUtil.sendMessage(session, wsEvent);
                break;
        }
    }

    private void queryUser(Session session, Manager manager, JSONObject data, UserMapper userMapper) {
        AdminTradeQueryUserParam queryUserParam = JSONObject.toJavaObject(data, AdminTradeQueryUserParam.class);
        Page<User> page = new Page<>(queryUserParam.getPage(),queryUserParam.getLimit());
        String like = "%" + queryUserParam.getId() + "%";
        Page<User> userPage = userMapper.userQueryForAdmin(page,manager.getId(),like,queryUserParam.getVip());

        WsEvent wsEvent = new WsEvent("adminTradeQueryUserRes", Result.success(userPage));
        WebsocketManagerUtil.sendMessage(session,wsEvent);
    }

    private void queryTrade(Session session, JSONObject data) {

    }

    private void refund(Session session, Manager manager, JSONObject data) {
    }
}
